#version 330 core

// Input vertex data, different for all executions of this shader.
in vec3 vertexPosition;
in vec3 vertexNormal;
in vec2 vertexUV;

// Values that stay constant for the whole mesh.
uniform mat4 MVP;
uniform sampler2D displaceTexture;
uniform float displace;

void main(){

        // Output position of the vertex, in clip space : MVP * position
        vec2 newUV;
        newUV.x = vertexUV.x + displace;
        newUV.y = vertexUV.y + displace;
        if (newUV.x > 1) newUV.x -= 1;
        if (newUV.y > 1) newUV.y -= 1;
        float strength = texture2D(displaceTexture, newUV).r/3;//*(displace*0.5);
        vec3 to = vertexNormal*strength;

        gl_Position =  MVP * (vec4(vertexPosition,1)+vec4(to,1));
}

