#version 330 core
// Source: Omni-directional Shadows, Peter Houska
// Institute of Computer Graphics and Algorithms
in vec4 WS_pos_from_GS;

uniform vec2 near_far; // near and far plane for cm-cams
uniform vec4 l_pos; // world space light position

void main(void) {
	// calculate distance
	float WS_dist = distance(WS_pos_from_GS, l_pos);

	// map value to [0;1] by dividing by far plane distance
	float WS_dist_normalized = WS_dist / near_far.y;

	// write modified depth
	gl_FragDepth = WS_dist_normalized;
}