#version 330 core

// Input vertex data, different for all executions of this shader.
in vec3 vertexPosition;
in vec3 vertexNormal;
in vec2 vertexUV;

// Output data ; will be interpolated for each fragment.
out vec2 uv;
//out vec3 pos;
out vec3 normal;
out vec3 lightDir;

// shadow mapping: WS position for cubemap lookup
out vec4 WS_pos;

// Values that stay constant for the whole mesh.
uniform mat4 MVP;
uniform mat4 ModelMatrix;
uniform mat4 ViewMatrix;
uniform mat4 NormalMatrix;
uniform vec3 light;

void main(){

		WS_pos = ModelMatrix * vec4(vertexPosition,1);

        // Output position of the vertex, in clip space : MVP * position
        gl_Position =  MVP * vec4(vertexPosition,1);

        // UV of the vertex. No special space for this one.
        uv = vertexUV;

        //Position in worldSpace
        vec3 pos = vec3((ModelMatrix)*vec4(vertexPosition,1));

        //Normal in worldSpace
        //mat4 normalMa = transpose(inverse(ViewMatrix * ModelMatrix));
        normal = normalize(vec3(NormalMatrix*vec4(vertexNormal,1)));

        //light is in worldSpace
        lightDir = normalize(light-pos);
}
