#version 330 core

// Input vertex data, different for all executions of this shader.
in vec3 vertexPosition;
in vec2 vertexUV;

// Output data ; will be interpolated for each fragment.
out vec2 uv;

// Values that stay constant for the whole mesh.
uniform mat4 MVP;

void main(){

        // Output position of the vertex, in clip space : MVP * position
        gl_Position =  MVP * vec4(vertexPosition,1);

        // UV of the vertex. No special space for this one.
        uv = vertexUV;
}

